# coding: utf-8

"""
    aind-labtracks-service

     ## aind-labtracks-service  Service to fetch data from LabTracks.  

    The version of the OpenAPI document: 0.2.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class MouseCustomClass(BaseModel):
    """
    Schema for MouseCustomClass that will be parsed from XML
    """ # noqa: E501
    reserved_by: Optional[StrictStr] = None
    reserved_date: Optional[StrictStr] = None
    reason: Optional[StrictStr] = None
    solution: Optional[StrictStr] = None
    full_genotype: Optional[StrictStr] = None
    phenotype: Optional[StrictStr] = None
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["reserved_by", "reserved_date", "reason", "solution", "full_genotype", "phenotype"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MouseCustomClass from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        # set to None if reserved_by (nullable) is None
        # and model_fields_set contains the field
        if self.reserved_by is None and "reserved_by" in self.model_fields_set:
            _dict['reserved_by'] = None

        # set to None if reserved_date (nullable) is None
        # and model_fields_set contains the field
        if self.reserved_date is None and "reserved_date" in self.model_fields_set:
            _dict['reserved_date'] = None

        # set to None if reason (nullable) is None
        # and model_fields_set contains the field
        if self.reason is None and "reason" in self.model_fields_set:
            _dict['reason'] = None

        # set to None if solution (nullable) is None
        # and model_fields_set contains the field
        if self.solution is None and "solution" in self.model_fields_set:
            _dict['solution'] = None

        # set to None if full_genotype (nullable) is None
        # and model_fields_set contains the field
        if self.full_genotype is None and "full_genotype" in self.model_fields_set:
            _dict['full_genotype'] = None

        # set to None if phenotype (nullable) is None
        # and model_fields_set contains the field
        if self.phenotype is None and "phenotype" in self.model_fields_set:
            _dict['phenotype'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MouseCustomClass from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "reserved_by": obj.get("reserved_by"),
            "reserved_date": obj.get("reserved_date"),
            "reason": obj.get("reason"),
            "solution": obj.get("solution"),
            "full_genotype": obj.get("full_genotype"),
            "phenotype": obj.get("phenotype")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


